#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <PubSubClient.h>
#include <EEPROM.h>
extern "C" {
#include "user_interface.h"
}
#define LEDpin 1        // LED zum Blinken. Bei ESP-07 Pin 2. Bei ESP-01 Pin 1
#define Taster 0 // Pin der an Taster angeschlossen ist
#define QoS 0
#define DNS
IPAddress apIP(192, 168, 168, 30);

#if defined DNS
#include <DNSServer.h>
const byte DNS_PORT = 53;
DNSServer dnsServer;
#endif

char ssid[32] = "fhgdhfghd\0";
char passwort[64] = "gghdfgh\0";
String konfig[7];
#define BUFFER_SIZE 100

ESP8266WebServer server;
EspClass esp;
int z = 0;                   //Aktuelle EEPROM-Adresse zum lesen
#include "Setup2.h"
int i = 0;

WiFiClient wclient;
PubSubClient client(wclient);
void setup()                // Wird 1 Mal beim Start ausgefuehrt
{
  char inser;               // Serielle daten ablegen
  pinMode(Taster, INPUT_PULLUP);
  EEPROM.begin(512);                                 // EEPROM initialisieren mit 200 Byts

  //------------------------------------ Prüfen ob Tx und Rx verbunden sind --------------
  Serial.begin(115200);
  while (Serial.available())inser = Serial.read();
  Serial.println("Start");
  delay(10);
  inser = Serial.read();
  if (inser != 'S') goto weiter;
  inser = Serial.read();
  if (inser != 't') goto weiter;
  pinMode(LEDpin, OUTPUT);
  digitalWrite(LEDpin, 0);
  Einstellen();

weiter:
  z = 0;
  LeseEeprom(ssid, sizeof(ssid));        // EEPROM lesen
  if (ssid[0] == 255) // Wenn EEPROM leer ist dann:
  {
    for (i = 0; i < 20; i++) EEPROM.write(i, '\0');
    EEPROM.commit();
    pinMode(LEDpin, OUTPUT);
    digitalWrite(LEDpin, 0);
    Einstellen();
  }
  LeseEeprom(passwort, sizeof(passwort));
  for (int k = 0; k < 7; k++) LeseEepromStr(&konfig[k], 60);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, passwort);
  WiFi.hostname("MQTT-Taster");
  int timout = 0;
  pinMode(LEDpin, OUTPUT);
  while (WiFi.status() != WL_CONNECTED)
  {
    timout++;
    if  (timout > 60) // Wenn Anmeldung nicht möglich
    {
      digitalWrite(LEDpin, 0);    // LED ON für 5 Sekunden
      delay(5000);
      digitalWrite(LEDpin, 1);
      esp.reset();
      delay(100);
    }        // End timeout
    delay(100);
    digitalWrite(LEDpin, 0);
    delay(100);
    digitalWrite(LEDpin, 1);
    delay(100);
  }                         // Verbunden

  Serial.begin(115200);
  Serial.println("");
  Serial.println("Start");
  /*
    delay(1000);
    for (int k = 0; k < 7; k++) Serial.println(konfig[k]);
    delay(1000);
  */
}

void callback(const MQTT::Publish& pub)      // Diese funktion wird bei empfang einer subscribe Publish ausgeführt
{
  String Empfangen = pub.payload_string();   // Auswertung der empfanener Nachrichts
}

void loop()
{
  if (WiFi.status() == WL_CONNECTED)
  {
    if (!client.connected()) //------------------------- MQTT nicht verbunden ----------------------------------------
    {
      client.set_server(konfig[0], konfig[1].toInt());
      if (client.connect(MQTT::Connect(konfig[4]).set_auth(konfig[2], konfig[3])))
      {
        client.publish(MQTT::Publish("Hallo", konfig[4]).set_qos(QoS));
        client.set_callback(callback);
        //Serial.println("Mit MQTT verbunden");
      }
    } //----------------------------------------------- ende MQTT nicht verbunden -------------------------------------

    if (client.connected()) // MQTT  verbunden
    {
      client.loop();
      if (!digitalRead(Taster)) //Taster betätigt
      {
        delay(50);
        if (!digitalRead(Taster)) // Nach 50ms immer noch betätigt dann ist es keine Induktionstrom in der Leitung
        {
          //Serial.println("Taster betaetigt");
          client.publish(MQTT::Publish(konfig[5], konfig[6]).set_qos(QoS));
          while (!digitalRead(Taster))client.loop();
        } // ende Taster nach 50 ms
      } // ende Taster betaetigt betaetigt

    }// ende mit MQTT verbunden
  } // ende mit WLAN verbunden
  yield();
}




